/*
 * AprlInit.c
 * 
 * Entry function for APRL shared library - provides init function
 * 
 * 1996sep30 dpwe@icsi.berkeley.edu
 *
 * $Header: /u/drspeech/src/tcltk/aprl/RCS/AprlInit.c,v 1.1 1996/11/18 18:42:29 dpwe Exp dpwe $
 */

#include <tcl.h>

/* Package-related constants */
#define APRL_PKGNAME "APRL"
/* #define APRL_VERSION "1.0" */
/* APRL_VERSION comes in on compile line now */

extern int Scheduler_Init(Tcl_Interp *interp);
extern int WaveSink_Init(Tcl_Interp *interp);
extern int Timeline_Init(Tcl_Interp *interp);
extern int VUMeter_Init(Tcl_Interp *interp);
extern int Needle_Init(Tcl_Interp *interp);
extern int thresh_Init(Tcl_Interp *interp);
extern int audiosrc_Init(Tcl_Interp *interp);
extern int audiosink_Init(Tcl_Interp *interp);
extern int bpfilter_Init(Tcl_Interp *interp);
extern int lpfilter_Init(Tcl_Interp *interp);
extern int hpfilter_Init(Tcl_Interp *interp);
extern int randsrc_Init(Tcl_Interp *interp);
extern int rms_Init(Tcl_Interp *interp);
extern int soundfsrc_Init(Tcl_Interp *interp);
extern int soundfsink_Init(Tcl_Interp *interp);
extern int adder_Init(Tcl_Interp *interp);
extern int multer_Init(Tcl_Interp *interp);
extern int dB_Init(Tcl_Interp *interp);
extern int delay_Init(Tcl_Interp *interp);
extern int nthresh_Init(Tcl_Interp *interp);
extern int eventer_Init(Tcl_Interp *interp);
extern int ptrack_Init(Tcl_Interp *interp);
extern int decimer_Init(Tcl_Interp *interp);
extern int linterper_Init(Tcl_Interp *interp);
extern int UserCmd_Init(Tcl_Interp *interp);

int Aprl_Init(Tcl_Interp *interp)
{
    /* Do the package housekeeping */
    Tcl_PkgProvide(interp, APRL_PKGNAME, APRL_VERSION);

    /* Initialize the package */
    if (thresh_Init(interp) == TCL_ERROR)  {	return TCL_ERROR;    }
    if (audiosrc_Init(interp) == TCL_ERROR)  {	return TCL_ERROR;    }
    if (audiosink_Init(interp) == TCL_ERROR)  {	return TCL_ERROR;    }
    if (bpfilter_Init(interp) == TCL_ERROR)  {	return TCL_ERROR;    }
    if (lpfilter_Init(interp) == TCL_ERROR)  {	return TCL_ERROR;    }
    if (hpfilter_Init(interp) == TCL_ERROR)  {	return TCL_ERROR;    }
    if (randsrc_Init(interp) == TCL_ERROR)  {	return TCL_ERROR;    }
    if (rms_Init(interp) == TCL_ERROR)  {	return TCL_ERROR;    }
    if (soundfsrc_Init(interp) == TCL_ERROR)  {	return TCL_ERROR;    }
    if (soundfsink_Init(interp) == TCL_ERROR) {	return TCL_ERROR;    }
    if (adder_Init(interp) == TCL_ERROR) {	return TCL_ERROR;    }
    if (multer_Init(interp) == TCL_ERROR) {	return TCL_ERROR;    }
    if (dB_Init(interp) == TCL_ERROR) {	return TCL_ERROR;    }
    if (delay_Init(interp) == TCL_ERROR) {	return TCL_ERROR;    }
    if (nthresh_Init(interp) == TCL_ERROR) {	return TCL_ERROR;    }
    if (eventer_Init(interp) == TCL_ERROR) {	return TCL_ERROR;    }
    if (ptrack_Init(interp) == TCL_ERROR) {	return TCL_ERROR;    }
    if (decimer_Init(interp) == TCL_ERROR) {	return TCL_ERROR;    }
    if (linterper_Init(interp) == TCL_ERROR) {	return TCL_ERROR;    }

    if (UserCmd_Init(interp) == TCL_ERROR) {	return TCL_ERROR;    }

    if(Timeline_Init(interp) == TCL_ERROR)  {
	return TCL_ERROR;
    }
    if(VUMeter_Init(interp) == TCL_ERROR)  {
	return TCL_ERROR;
    }
    if(Needle_Init(interp) == TCL_ERROR) {
    return TCL_ERROR;
    }
    if (WaveSink_Init(interp) == TCL_ERROR)  {
	return TCL_ERROR;
    }
    if (Scheduler_Init(interp) == TCL_ERROR)  {
	return TCL_ERROR;
    }

    return TCL_OK;
}

