// -*- C++ -*-

// SoundfileIO.h
//
// Classes for sources and sinks of data
// that interface to soundfile read/write
// for Audio Pattern Recognition Language (aprl)
// dpwe@media.mit.edu 1995feb02
//
/* $Header: /u/drspeech/src/tcltk/aprl/RCS/SoundfileIO.h,v 1.2 1997/07/19 01:27:27 dpwe Exp $ @media.mit.edu Machine Listening Group
 */

#include "DataPipe.h"
#include "Sound.H"

#define DATAFORMAT Sfmt_FLOAT	/* if DATA==float, this must match */

#define DFLT_SRATE 	(22050.0)
#define DFLT_BUFTIME 	(0.100)

class SoundfileSrc : public DataSource, public Sound {
private:
    double bufferTime;
    double lastTime;
    int    loop;		// continually repeat input file
    double scale; 		// multiply the output by this.

public:
    SoundfileSrc(char *filename, double buftime = DFLT_BUFTIME);
    virtual ~SoundfileSrc(void)
        { };
    int newfile(char *filename);
    /* A new filename has been specified.  Open the associated soundfile
       if it looks like it might exist.  Return 1 on success, else 0. */
    int Update(double time);
    void SetLoop(int l)		{ loop = l; }
    int ThereIsMore(void)
        { return isOpen() && (loop || !Sound::frameFeof()); };
    double getScale(void)	{ return scale; }
    void setScale(double sc)	{ scale = sc; }
};
	
class SoundfileSink : public DataSink, public Sound {
private:
    char *fileName;
    int  isOpen;
    double scale; 		// multiply the input by this.

    void init(void)  
        { Sound::setSampleRate(Input()->SampleRate());
	  Sound::setChannels(1);
	  Sound::open(fileName); 
	  Sound::setFormat(DATAFORMAT);
	  isOpen = 1; }
public:
    SoundfileSink(char *fname, DataSource *in = 0)
	: Sound("w"), fileName(fname), DataSink(in)
	{ isOpen = 0; scale = 1.0;}
    virtual ~SoundfileSink(void)
        { };
    int Update(double /* time */);
    double getScale(void)	{ return scale; }
    void setScale(double sc)	{ scale = sc; }
};
	

	
