// -*- C++ -*-

// tclAprlMisc.h
//
// Miscillaneous pieces for the tcl interface
// for aprl - audio pattern recognition language
// dpwe@media.mit.edu 1995feb12
//

#ifndef _TCLAPRLMISC_H
#define _TCLAPRLMISC_H

#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <math.h>	/* for atof(), and good measure */
#include <string.h>	/* gets strdup too */

extern "C" {
#include <tcl.h>
#include <tk.h>
extern char *strdup(const char *s1);	// difficult to get this declared
}

#include "DataPipe.h"	// purely so we can declare globalDataSource here

#define NONESTR "<none>"


  // Remember the single, global scheduler to which all procs are added
extern Scheduler *globalScheduler;

  // Declare the hash table for figuring out DataSources
extern Tcl_HashTable datasrcTable;

  // Last data source created is stored in a global for shorthand builds
extern DataSource *globalDataSource;
extern char       *globalDSnameStr;

  // Prototypes of fns in tclAprlMisc.cc
char *UniqueSPName(Tcl_Interp *interp);	// generates name for schd proc
int ConfigSpecified(char *val, int argc, char **argv);
    // Checks config args for a particular specifier
int DSfromString(Tcl_Interp *interp, char **name, DataSource **ds, 
		 int takeDefault);
    // Return the data source keyed by the name <name> in the lookup 
    // table.  If no match and if <takeDefault>, return the 
    // last created source from <globalDataSource>, and modify *name
    // Returns TCL_ERROR and sets error msg if bad match


#endif /* _TCLAPRLMISC_H */
