//
// tclCompPipe.cc
//
// tcl interface to CompPipe objects
//
// for aprl - audio pattern recognition language
// dpwe@media.mit.edu 1995feb08
//

#include <stdio.h>
#include <assert.h>
#include "MiscPipes.h"

#define OBJECT         CompPipe
#define TCLNAME	       thresh
#define ISPIPE			/* one of ISSINK, ISSOURCE or ISPIPE */


#define STRUCTFIELDS	\
        double reference;


#define CONFIGLINES  	\
	CONFIGLINE(TK_CONFIG_DOUBLE, reference, Reference, "1.0")


#define COMMANDCODE(interp,ptr,c,argc,argv,length) \
    else if( (c=='b') && (strncmp(argv[1], "beep", length)==0) )  {	\
	if(argc!=2) {							\
	    Tcl_AppendResult(interp, "wrong # args: should be \"", 	\
			     argv[1], "\"", NULL);			\
	    return TCL_ERROR;						\
	} else {							\
	    fprintf(stderr, "\007");					\
	}								\
    }
    // note the leading 'else' to make it make sense in the code.  
    // But if no extra commands, can be just left completely blank

    // appended to the default command list
#define COMMANDLIST	"/beep"
    // leading slash acts as separator from that to which it is appended.
    // But just leave totally blank if no commands are to be added.

    // no IN field for CONSTRUCTCODE if TYPE==SOURCE
#define CONSTRUCTCODE(PTR, IN)				\
	PTR->obj = new OBJECT(PTR->reference, IN);	
    // we just defined OBJECT as the C++ object, but we could have used 
    // its actual name equally well.  PTR is a pointer to the TCL structure 
    // containing the fixed ->obj field.

    // PTR points to the tcl struct, which has a pointer named "obj"
    // pointing to the actual C++ object
#define CONFIGCODE(PTR)					\
	if(PTR->reference != PTR->obj->GetRef() )	\
	    PTR->obj->SetRef(PTR->reference);

#include "tclTemplate.h"	// actually define the fns etc.

