//
// tclEventPipe.cc
//
// tcl interface to EventPipe objects
//
// for aprl - audio pattern recognition language
// dpwe@media.mit.edu 1995feb08
//

#include <stdio.h>
#include <assert.h>
#include "EventPipe.h"

#define OBJECT         EventPipe
#define TCLNAME	       eventer
#define ISPIPE
#define STRUCTFIELDS	\
        double holdoffTime;	\
	double pulseTime;	\
	char   *command;
#define CONFIGLINES  	\
	CONFIGLINE(TK_CONFIG_DOUBLE, holdoffTime, HoldoffTime, "0.0")	\
	CONFIGLINE(TK_CONFIG_DOUBLE, pulseTime, PulseTime, "0.0")	\
	CONFIGLINE(TK_CONFIG_STRING, command, Command, "")
#define COMMANDCODE(interp,ptr,c,argc,argv,length)
#define COMMANDLIST	
#define CONSTRUCTCODE(PTR, IN)				\
	PTR->obj = new OBJECT(PTR->holdoffTime, PTR->pulseTime, \
			      eventerCallbackFn, (void *)PTR, IN);
#define CONFIGCODE(PTR)					\
	PTR->obj->SetTimes(PTR->holdoffTime, PTR->pulseTime);

// define the callback function

static void eventerCallbackFn(double time, void *udata);

#include "tclTemplate.h"	// actually define the fns etc.

static void eventerCallbackFn(double time, void *udata)
{	/* callback from event pipe - triggered */
    eventerStruct *es = (eventerStruct *)udata;
    if(es->command && strlen(es->command)>0)  {
	// must call the TCL fn
	char timestr[32];
	sprintf(timestr, " %.3f", time);
	int rslt = Tcl_VarEval(es->interp, es->command, timestr, 0);
	//fprintf(stderr, "evCB: command was '%s%s', rslt %d\n", 
	//	es->command, timestr, rslt);
    }    
}
