// -*- C++ -*-

// tclMiscPipes.cc
//
// tcl interface to the objects in MiscPipes.cc
//
// for aprl - audio pattern recognition language
//  dpwe, eds@media.mit.edu 9 Feb 1995
#ifndef lint
static char rcsid[] = "$Header: /n/crab/da/dpwe/src/aprl/tclMiscPipes.cc,v 1.1 1996/11/18 18:42:29 dpwe Exp $ @media.mit.edu Machine Listening Group";
#endif /* lint */

#include <stdio.h>
#include <assert.h>
#include "MiscPipes.h"

// ----------------------- TEMPLATE DECLARATION OF RANDSRC --------------

#define OBJECT		RandSrc
#define TCLNAME		randsrc
#define ISSOURCE
#define STRUCTFIELDS		\
    double	sampleRate;	\
    double	scale;		\
    double	bufferTime;	
#define CONFIGLINES		\
    CONFIGLINE(TK_CONFIG_DOUBLE, sampleRate, SampleRate, "8000.0")	\
    CONFIGLINE(TK_CONFIG_DOUBLE, scale, Scale, "1.0")			\
    CONFIGLINE(TK_CONFIG_DOUBLE, bufferTime, BufferTime, "0.5")
#define COMMANDCODE(interp,ptr,c,argc,argv,length)
#define COMMANDLIST	
#define CONSTRUCTCODE(PTR)	\
    PTR->obj = new RandSrc(PTR->sampleRate, 			\
			   (int)(PTR->sampleRate *PTR->bufferTime));	\
    PTR->obj->setScale(PTR->scale);
#define CONFIGCODE(PTR)		\
    PTR->obj->setScale(PTR->scale);

#include "tclTemplate.h"

// ----------------------- TEMPLATE DECLARATION OF RMSPIPE --------------

#define OBJECT		RmsPipe
#define TCLNAME		rms
#define ISPIPE
#define STRUCTFIELDS	\
    double sampleRate;
#define CONFIGLINES	\
    CONFIGLINE(TK_CONFIG_DOUBLE, sampleRate, SampleRate, "100.0")
#define COMMANDCODE(interp,ptr,c,argc,argv,length)
#define COMMANDLIST	
#define CONSTRUCTCODE(PTR,IN)	\
    PTR->obj = new RmsPipe(PTR->sampleRate, IN);
#define CONFIGCODE(PTR)		\
    /* nothing to reconfigure */

#include "tclTemplate.h"

// ----------------------- TEMPLATE DECLARATION OF DBPIPE --------------

#define OBJECT		DBPipe
#define TCLNAME		dB
#define ISPIPE
#define STRUCTFIELDS	\
    double reference;
#define CONFIGLINES	\
    CONFIGLINE(TK_CONFIG_DOUBLE, reference, Reference, "1.0")
#define COMMANDCODE(interp,ptr,c,argc,argv,length)
#define COMMANDLIST	
#define CONSTRUCTCODE(PTR,IN)	\
    PTR->obj = new OBJECT(PTR->reference, IN);
#define CONFIGCODE(PTR)		\
    PTR->obj->SetRef(PTR->reference);

#include "tclTemplate.h"

// ----------------------- TEMPLATE DECLARATION OF DELAY --------------

#define OBJECT		DelayPipe
#define TCLNAME		delay
#define ISPIPE
#define STRUCTFIELDS	\
    double initVal;	\
    double delayTime;
#define CONFIGLINES	\
    CONFIGLINE(TK_CONFIG_DOUBLE, initVal, InitVal, "0.0")	\
    CONFIGLINE(TK_CONFIG_DOUBLE, delayTime, DelayTime, "0.0")
#define COMMANDCODE(interp,ptr,c,argc,argv,length)
#define COMMANDLIST	
#define CONSTRUCTCODE(PTR,IN)	\
    PTR->obj = new OBJECT(PTR->delayTime, PTR->initVal, IN);
#define CONFIGCODE(PTR)		\
    PTR->obj->SetDelay(PTR->delayTime);

#include "tclTemplate.h"

// ----------------------- TEMPLATE DECLARATION OF NOTPIPE --------------

#define OBJECT		NotPipe
#define TCLNAME		nthresh
#define ISPIPE
#define STRUCTFIELDS	\
    double reference;
#define CONFIGLINES	\
    CONFIGLINE(TK_CONFIG_DOUBLE, reference, Reference, "1.0")
#define COMMANDCODE(interp,ptr,c,argc,argv,length)
#define COMMANDLIST	
#define CONSTRUCTCODE(PTR,IN)	\
    PTR->obj = new OBJECT(PTR->reference, IN);
#define CONFIGCODE(PTR)		\
    PTR->obj->SetRef(PTR->reference);

#include "tclTemplate.h"

