/*
 * dpweutilsTkInit.C
 * 
 * Init file for tk-specific bits of surfex shared lib
 * extensions to Tcl/Tk for the surfex blackboard sound understanding system
 *
 * 1996dec09 dpwe@icsi.berkeley.edu after tclsoundInit.cc
 * $Header: /u/drspeech/src/guitools/dpweutils_tcl/RCS/dpweutilsTkInit.C,v 1.3 1998/12/03 00:06:41 dpwe Exp $
 */

#include <tcl.h>
#include <tk.h>		// for Tk_CreatePhotoImageFormat()

extern "C" {
extern int Plot_Init(Tcl_Interp *interp);
extern int Timeline_Init(Tcl_Interp *interp);
extern int MiscTk_Init(Tcl_Interp *interp);
extern int ImgFmtFA_Init(Tcl_Interp *interp);
}

/* Initialization commands */
extern "C" int Dpweutils_tk_Init(Tcl_Interp *interp)
{   /* Package opening call */
    
    // for Tcl7.5+, signal the package mechanism
    Tcl_PkgProvide(interp, "Dpweutils_tk", DTUTILS_VERSION);

#ifdef HAVE_FARRAY
    if(Plot_Init(interp) == TCL_ERROR)		{ return TCL_ERROR; }
#endif /* HAVE_FARRAY */
    if(Timeline_Init(interp) == TCL_ERROR)	{ return TCL_ERROR; }
    if(MiscTk_Init(interp) == TCL_ERROR)	{ return TCL_ERROR; }

    if(ImgFmtFA_Init(interp) == TCL_ERROR)	{ return TCL_ERROR; }

    return TCL_OK;
}

extern "C" int Dpweutils_tk_SafeInit(Tcl_Interp *interp)
{   /* Package opening call */
    /* fprintf(stderr, "Tkutilsdpwe: cannot load under safe interpreter\n");
    return TCL_ERROR; */

    return Dpweutils_tk_Init(interp);
}

