/*
 * cppdummy.cc
 *
 * dummy C++ type things to force the final tclsh/wish
 * executable to be linked with C++-specific symbols like 
 * cerr and __pure_virtual.
 *
 * This is mainly to allow C++-derived "load"able libraries to 
 * work on sun4, which won't let me use g++ to link the 
 * shared library.  But it might be a good idea all round.
 *
 * 1997jul02 dpwe@icsi.berkeley.edu
 * $Header: /n/yam/da/dpwe/src/tcl/tclsh-readline/RCS/cppdummy.cc,v 1.4 1998/01/26 05:33:30 dpwe Exp $
 */

#include <iostream.h>
#include <stdio.h>
#include <stdlib.h>	// for abort - for Solaris CC's expansion of assert
#include <assert.h>

class A {
protected:
    int i;
public:
    A(int j);
    // make sure that we have cause for __pure_virtual
    virtual int foo(void)=0;
};

class B : public A {
private: 
    int j;
public:
    B(void);
    int foo(void);
};

A::A(int j) {
    i = j;
}

B::B(void) : A(0) {
    j = i;
    // make sure that we have cause for _cerr, and some cast methods
    cerr << "B created (i=" << i << "@" << (void *)this << ")" << endl;
}

int B::foo(void) {
    ++i;
    ++j;
    // make sure that any funkiness in assert comes in (__eprintf under gcc2.7)
    assert(j<100);
    return j;
}

void mydummy() {
  A *a = new B();
  a->foo();
}

